package com.ruoyi.app.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ruoyi.app.domain.*;
import com.ruoyi.app.service.ITbFamilyService;
import com.ruoyi.app.service.ITbGardenImgService;
import com.ruoyi.common.utils.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.app.mapper.TbFamilyGardenMapper;
import com.ruoyi.app.service.ITbFamilyGardenService;

import java.util.ArrayList;
import java.util.List;

/**
 * 家族园地
 *
 * @author liuhj
 * @date 2020-10-14
 */
@Service
public class TbFamilyGardenServiceImpl extends ServiceImpl<TbFamilyGardenMapper, TbFamilyGarden> implements ITbFamilyGardenService {
    @Autowired
    private ITbFamilyService familyService;
    @Autowired
    private ITbGardenImgService gardenImgService;


    @Override
    public List<TbFamilyGarden> queryList(TbFamilyGarden  entity) {
        LambdaQueryWrapper<TbFamilyGarden> lqw = new LambdaQueryWrapper<TbFamilyGarden>().orderByDesc(TbFamilyGarden::getCreateTime);
        if (entity.getFamilyId() != null){
            lqw.eq(TbFamilyGarden::getFamilyId ,entity.getFamilyId());
        }
        if (StringUtils.isNotBlank(entity.getTitle())){
            lqw.like(TbFamilyGarden::getTitle ,entity.getTitle());
        }
        List<TbFamilyGarden> list = this.list(lqw);
        list.forEach(item->{
            TbFamily family = familyService.getById(item.getFamilyId());
            item.setFamily(family);
        });

        if(entity.getId() != null)
        {
            List<Long> ids = new ArrayList<>();
            list.forEach(item -> {
                ids.add(item.getId());
            });
            List<TbGardenImg> imgList = gardenImgService.list(new LambdaQueryWrapper<TbGardenImg>()
                    .in(TbGardenImg::getGardenId, ids)
            );
            list.forEach(item -> {
                // 加入图片列表
                List<TbGardenImg> imgs = new ArrayList<>();
                imgList.forEach(img -> {
                    if (img.getGardenId().equals(item.getId())) {
                        imgs.add(img);
                    }
                });
                item.setImgList(imgs);
            });

        }

        return list;
    }

    /**
     * 家族园地详情
     * @param id
     * @return
     */
    @Override
    public TbFamilyGarden getFamilyGarden(Long id) {
        TbFamilyGarden familyGarden = this.getById(id);
        if (familyGarden != null) {
            List<TbGardenImg> eventImgs = gardenImgService.list(new LambdaQueryWrapper<TbGardenImg>()
                    .in(TbGardenImg::getGardenId, id)
            );

            familyGarden.setImgList(eventImgs);
        }
        return familyGarden;
    }
}
